%% CSTR-distillation process alldata_dataH_CSTRdest2.m %%
% 07.06.14 


%%  Step 1
% Generate data from case study matrices 
% The data along with other parameters are calculated in other scrips
% The relevant parameters and data is loaded here
load cstrdest.mat       % Gives: 'y','d_cost','ns','y_opt','Wn','yn','Wd','Y','F','dF0'
load gainmat.mat        % Gives Gy
load destgainmat.mat    % Gives Gyd


%% Step 2
% Here the number of measurements, inputs and disturbances are given. And 
% The number of components to be used in the PLS-regnression. The number of
% Components are found in a different script. 

ny = 10;
nd = 1; % F0
nu = 1; % L

%% Choosing the case 
% nr. of y, incl. the disutbance or not, with or without noise

if casenr == 1
    disp('10 measurements without dist ')
% Not including the disturbance in the measurement: %
%y = [8     13 	  18 	22 	    Lt	   Vb     D      B 	   F      zf ]  (10 measurements)
        ny=10 ;
        Gy=Gy;
        Yexl = Yexl ; 
        F = F;
        if case_n == 1;
        Ally = y(:,1:size(y,2)) ; % No noise   
        disp('no measurement noise')
        elseif case_n == 2 
        Ally = yn(:,1:size(yn,2)); % With noise 
          disp('with measurement noise')
        end 

elseif casenr == 2
      disp('10 measurements with dist ')  
% Including the disturbance in the measurements: % 
%y = [8     13  	22 	    Lt	   Vb     D      B 	   F      zf     F0]  (10 measurements)
           ny=10 ;
           Gy=Gy9;
           Yexl = Yexl9 ; 
           F = F9;
        if case_n == 1;
            Ally = y9(:,1:size(y9,2)) ; % No noise 
              disp('no measurement noise')
        elseif case_n == 2 
            Ally = yn9(:,1:size(yn9,2)); % With noise 
               disp('with measurement noise')
        end 


elseif casenr == 3
     disp('5 measurements without dist ')
% Using only 5 measurements, excl. disturbance F0 %
           ny=5 ;
           Gy=Gy5nd;
           Yexl = Yexl5nd ; 
           F = F5nd;
        if case_n == 1;
            Ally = y5nd(:,1:size(y5nd,2)) ; % No noise
              disp('no measurement noise')
        elseif case_n == 2 
            Ally = yn5nd(:,1:size(yn5nd,2)); % With noise
               disp('with measurement noise')
        end 

elseif casenr == 4
     disp('5 measurements with dist ')   
% Using only 5 measurements, incl. disturbance F0 %
           ny=5 ;
           Gy=Gy5;
           Yexl = Yexl5 ; 
           F = F5;  
        if case_n == 1;
            Ally = y5(:,1:size(y5,2)) ; % No noise
              disp('no measurement noise')
        elseif case_n == 2 
            Ally = yn5(:,1:size(yn5,2)); % With noise
               disp('with measurement noise')
        end 
        
end 
%% Step 3
% Center the data
% If the data is fabricated using random disturbance and change in the
% inputs to "calculate" data, the data is already centered. And we can skip
% this step. 
% Each element in a row minus the mean of the row
% Ym=mean(Ally,2)
% Ym=kron(Ym,ones(1,ns))
% Y=Ally-Ym                % Ally with centered data 

% Scaling the values - the data must be scaled!
% This is done by finding the maximum value of a variable among all the samples, 
% and dividing the samples on the maximum value. 
Ymax = max(abs(Ally'))' ;
Yscal=[];
for i=1:ny
    Yscal(i,:) = Ally(i,:)/Ymax(i,1);
end
    
scy = diag(Ymax) ;

%% Step 4
% Finding Yaug to be able to fit a quadratic cost function
Yadd=[] ;
l=1 ;
for i =1:size(Ally,1)
    for j =i:size(Ally,1)
        Yadd(l,:) = Yscal(i,:).*Yscal(j,:) ;
        l=l+1 ;
    end
end

Yaug=[Yscal; Yadd];

%% Step 5
% Centering and scaling the cost function
Jorg = d_cost(1,1:size(d_cost,2))';
J=Jorg-repmat(mean(Jorg),ns,1); %centered

Jmax=max(abs(J));
Jscal=J/Jmax;


%% Step 6
% Running the PLS-regression

[P,Q,T,U,beta,pctvar] = plsregress(Yaug',Jscal,ncomp);
% X-scores T
% X-loadings W
% Y-scores U
% Y loading C
beta=beta' ;
 
% The modeled cost funtion 
Test=[ones(ns,1) Yaug']*beta';
 
% Making Jyy:
a=0 ;
for i=1:ny
    for j=i:ny
        Jy(i,j)=beta(ny+2+a);
        a=a+1;
    end 
end
Jy=Jy;
Jyy=Jy+Jy';


%% Step 7 
% Calculating and scaling back the H matrix
Hmat=[Gy';zeros(nd,ny)]*Jyy ; 
Hmat=[Gy';zeros(nd,ny)]*Jyy/scy; 
Hmat = Hmat(1:nu,:)              ;   % This is the "first H-matrix we found before any scaling
Hmatsc = Hmat(1:nu,1:nu)\Hmat     ;  % Scaled H matrix 
%H = Hns(1:nu,1:nu)\Hns   ;               % H from Jcomp*Gp    
%Haux =[Gy'; zeros(2,4)]*Jyy/scY(1:4,1:4);
 
%res = H-Hmatsc ;

% figure(1)
% plot(1:ncomp,cumsum(100*pctvar(2,:)),'-bo');
% xlabel('number of PLS components')
% ylabel('Precent Varance Explained in J')


%% Exact local method and null space

Hexl=Gy'*(Yexl*Yexl')^(-1);
%disp('tror ikke Y*Y er interverbar')
Hns = null(F')';

J_test = [ones(ns,1) Yaug']*beta';
J_diff = Jscal - J_test;

%figure(1)
%bar([1:ns], J_diff)


save('hmatrix','Hmat','Hexl','Hns','beta', 'J_diff')