%% DUMMY CASE : dummygeneratedata.m %%
%% 07.06.14 %%
% % % % % % % % % % % % % % % % % % % % % % % 
%% Number of variables, inputs and disturbances 
% Choose the case you want to run % 
% %CASE A
ny =3 ;      % measurments 
ns =50;      % samples 
nu =2 ;      % inputs 
nd =1;       % disturbances  

% % % % % % % % % % % % % % % % % % % % % % % 

% Case B
% ny =6 ;      % measurments 
% ns =5000;      % samples 
% nu =4 ;      % inputs 
% nd =2;       % disturbances 
% % ncomp=10;


% % % % % % % % % % % % % % % % % % % % % % % 

%% Generating parameters randomly
Gy=randn(nu,ny)';
Gyd=randn(nd,ny)';

Juu=randn(nu,nu);
Jud=randn(nd,nu)'; 
Jdu=randn(nd,nu);
Jdd=randn(nd,nd);

Jsd=[Juu' Jud;Jdu Jdd];  %the second derivative values

Gp=[Gy Gyd];
Jcomb=[Juu' Jud];

H=Jcomb*pinv(Gp) ;  % pseudoinverse of Gp

%% PLS test
% Random inputs and disturbances: 
allud=rand(ns,nu+nd); 


%The measurement y=Gy*u + Gyd*d = Gp*[u d]' 

%Each row is a variable (yi) and each column is a measurement of this
%variable (n_yi)

Ally=(Gp*allud');

%Cost function:

Jwhole=allud*Jsd*allud';

J=diag(Jwhole);

% Centering: 
J=J-repmat(mean(J),ns,1);

% Scaling:
Jmax=max(abs(J));
Jscal=J/Jmax;
          
%%%%%
% FIX THE SCALING AND CENTERING: THIS IS THE BEST DUMMYCASEFILE!! 
%%%%%


% Center the data (it isn't scaled)
% each element in a row minus the mean of the row
Ym=mean(Ally,2);
Ym=kron(Ym,ones(1,ns));
Y=Ally-Ym  ;


% Scaling the values - the data must be scaled!
% This is done by finding the maximum value of a variable among all the samples, 
% and dividing the samples on the maximum value. 
Ymax = max(abs(Ally'))' ;
Yscal=[];
for i=1:ny
    Yscal(i,:) = Y(i,:)/Ymax(i,1);
end
    
scy = diag(Ymax) ;


%% 
% Finding Yaug to be able to fit a quadratic cost function
Yadd=[] ;
l=1 ;
for i =1:size(Ally,1)
    for j =i:size(Ally,1)
        Yadd(l,:) = Yscal(i,:).*Yscal(j,:) ;
        l=l+1 ;
    end
end

Yaug=[Yscal; Yadd];



F=(-Gy*Juu*Jud)+Gyd;



save('dummyA', 'Yaug', 'Jscal', 'Gy','scy','H','Juu','F')
%save('gendatadummyB3', 'Yaug', 'Jscal', 'Gy','scy','H')